#version 330

//use reflect or refract
#define REFLECT

//do inverse transform
#define INVERSE_TRANSFORM


#define INV_VIEW_NORMAL


layout(std140) uniform Matrices
{
	mat4 m_pvm;
	mat4 m_viewModel;
	mat3 m_view;
	mat3 m_normal;
};

in vec4 position;	// local space
in vec3 normal;		// local space

out vec3 texCoord;

//----------------------------------------------------------------
// TODO:
// 1) Pass position to the fragment shader - renders sphere with image on it.
// 2) Pass reflected view direction in eye space - reflective sphere, camera independent.
// 3) Pass reflected view direction in world space - reflective sphere, camera dependent: texCoord = vec3(inverse(m_view) * vec4(reflectView, 0.f));
// 4) Try refraction - needs closer skybox to be apparent.
// 5) Zoom the sphere - what happens and why?
//----------------------------------------------------------------

void main()
{

	////TODO 1)
	//// Pass position to the fragment shader
	//texCoord = position.xyz;

	//TODO 2)
	// Calculate first in camera / view space.
	vec4 vertexView = m_viewModel * position;
	vec3 normalView = normalize(m_normal * normal);
	vec3 incident = vec3(vertexView);

	//  Compute reflection
	//vec3 reflectView = reflect(incident, normalView);

	//TODO 4)
	vec3 reflectView = refract(incident, normalView, 1.6f);


	//  Pass reflected view direction in eye space
	//  result will be camera independent
	//texCoord = reflectView;

	//TODO 3)
	texCoord = vec3(inverse(m_view) * reflectView);
	


	// common for all variants  
	//pass transformed position
	gl_Position = m_pvm * position;
}